###[DEF]###
[name		=	Warmwasser					]

[e#1		=	Dauerladung D #init=0		] 
[e#2		=	Soll-Temperatur D #init=35	]
[e#3		=	Offset D #init=3			]
[e#4		=	Einmalladung A #init=0		]
[e#5		=	Soll-Temperatur A #init=35	]
[e#6		=	Offset A #init=3			]
[e#7		=	Einmalladung B #init=0		]
[e#8		=	Soll-Temperatur B #init=45	]
[e#9		=	Offset B #init=3			]
[e#10		=	Ist-Temperatur				]

[a#1		=	Status D	]
[a#2		=	Status A	]
[a#3		=	Status B	]
[a#4		=	Warm D?		]
[a#5		=	Warm A?		]
[a#6		=	Warm B?		]
[a#7		=	Boiler 0/1	]

[v#1		=0				] 1=Dauerladung aktiviert
[v#2		=0				] 1=Einmalladung A aktiviert
[v#3		=0				] 1=Einmalladung B aktiviert
###[/DEF]###


###[HELP]###
Der Baustein wird lediglich durch die Ist-Temperatur (und die Eingänge E1/E4/E7) getriggert. Eine Änderung z.B. der Solltemperatur wird erst beim nächsten Triggern berücksichtigt, also z.B. wenn die Ist-Temperatur sich geändert hat oder E1/E4/E7 aktualisiert wurden.

Verhalten:
- die neue Aktivierung einer Einmalladung (E4=1 oder E7=1) übersteuert eine evtl. aktivierte Dauerladung
	- nach Beendigung der Einmalladung (manuell oder bei Erfolg) führt ggf. wieder zu einer aktiven Dauerladung (falls diese aktiviert wurde)
	- die Einmalladungen toggeln sich gegenseitig:
		- läuft also z.B. A und wird dann B aktiviert, wird A automatisch und dauerhaft deaktiviert
		- nach Beendigung von B ist dann keine der beiden Einmalladungen mehr aktiv!
		- die Dauerladung bleibt davon unberührt und wird ggf. dann wieder aktiviert


E1: Dauerladung Ein/Aus (1=Ein, 0=Aus)
E2: Maximaltemperatur (Sollwert) für Dauerladung
E3: Dauerladung:: Einschalttemperatur: Offset von Maximaltemperatur

E4: Einmalladung A (1=Starten, 0=Abbruch): ein neues(!) Telegramm =1 triggert die Einmalladung, diese kann mit 0 abgebrochen werden
E5: Maximaltemperatur (Sollwert) für Einmalladung A
E6: Einschalttemperatur: Offset A von Maximaltemperatur

E7: Einmalladung B (1=Starten, 0=Abbruch): ein neues(!) Telegramm =1 triggert die Einmalladung, diese kann mit 0 abgebrochen werden
E8: Maximaltemperatur (Sollwert) für Einmalladung B
E9: Einschalttemperatur: Offset B von Maximaltemperatur

E10: Ist-Temperatur (die reale Wassertemperatur im Boiler)


A1: Status: Dauerladung ist gerade aktiv (1/0)
A2: Status: Einmalladung A ist gerade aktiv (1/0)
A3: Status: Einmalladung B ist gerade aktiv (1/0)
A4: Dauerladung: 0=Wasser ist "kalt", 1=Wasser ist warm (also im Toleranzbereich)
A5: Einmalladung A: 0=Wasser ist "kalt", 1=Wasser ist warm (also im Toleranzbereich)
A6: Einmalladung B: 0=Wasser ist "kalt", 1=Wasser ist warm (also im Toleranzbereich)
A7: Boiler 0/1

<b>Hinweis:</b>
Alle Ausgänge werden nicht(!) nur bei einer Änderung gesetzt, ggf. ist also mit einem Send-By-Change-Baustein zu arbeiten.
###[/HELP]###


###[LBS]###
<?
function LB_LBSID($id) {
	if ($E=logic_getInputs($id)) {

		$refresh=false;

		//Einmalladung A
		//-----------------------------------
		if ($E[4]['refresh']==1) { 			
			$refresh=true;
			if ($E[4]['value']!=0) {											//Aktivieren
				if ($E[10]['value']<=($E[5]['value']-$E[6]['value'])) {			//Einschalttemperatur erreicht
					logic_setVar($id,2,1);		//Einmalladung A aktiviert
					logic_setVar($id,3,0);		//Einmalladung B deaktiviert
					logic_setOutput($id,1,0); 	//Status Dauerladung Aus
					logic_setOutput($id,2,1); 	//Status Einmalladung A Ein
					logic_setOutput($id,3,0); 	//Status Einmalladung B Aus
					logic_setOutput($id,7,1); 	//Boiler Ein
				} else {														//Ausschalttemperatur erreicht
					logic_setVar($id,2,0);		//Einmalladung A deaktiviert
					logic_setVar($id,3,0);		//Einmalladung B deaktiviert
					logic_setOutput($id,2,0); 	//Status Einmalladung A Aus
					logic_setOutput($id,3,0); 	//Status Einmalladung B Aus
					logic_setOutput($id,7,0); 	//Boiler Aus
				}
			} else {															//Deaktivieren
				logic_setVar($id,2,0);			//Einmalladung A deaktiviert
				logic_setVar($id,3,0);			//Einmalladung B deaktiviert
				logic_setOutput($id,2,0); 		//Status Einmalladung A Aus
				logic_setOutput($id,3,0); 		//Status Einmalladung B Aus
				logic_setOutput($id,7,0); 		//Boiler Aus
			}
		}

		//Einmalladung B
		//-----------------------------------
		if ($E[7]['refresh']==1) { 			
			$refresh=true;
			if ($E[7]['value']!=0) {											//Aktivieren
				if ($E[10]['value']<=($E[8]['value']-$E[9]['value'])) {			//Einschalttemperatur erreicht
					logic_setVar($id,2,0);		//Einmalladung A deaktiviert
					logic_setVar($id,3,1);		//Einmalladung B aktiviert
					logic_setOutput($id,2,0); 	//Status Einmalladung A Aus
					logic_setOutput($id,3,1); 	//Status Einmalladung B Ein
					logic_setOutput($id,7,1); 	//Boiler Ein
				} else {														//Ausschalttemperatur erreicht
					logic_setVar($id,2,0);		//Einmalladung A deaktiviert
					logic_setVar($id,3,0);		//Einmalladung B deaktiviert
					logic_setOutput($id,1,0); 	//Status Dauerladung Aus
					logic_setOutput($id,2,0); 	//Status Einmalladung A Aus
					logic_setOutput($id,3,0); 	//Status Einmalladung B Aus
					logic_setOutput($id,7,0); 	//Boiler Aus
				}
			} else {															//Deaktivieren
				logic_setVar($id,2,0);			//Einmalladung A deaktiviert
				logic_setVar($id,3,0);			//Einmalladung B deaktiviert
				logic_setOutput($id,2,0); 		//Status Einmalladung A Aus
				logic_setOutput($id,3,0); 		//Status Einmalladung B Aus
				logic_setOutput($id,7,0); 		//Boiler Aus
			}
		}
				
		//Dauerladung
		//-----------------------------------
		if ($E[1]['refresh']==1) { 	
			$refresh=true;
			if ($E[1]['value']!=0) {											//Aktivieren
				logic_setVar($id,1,1);			//Dauerladung aktiviert
				if ($E[10]['value']<=($E[2]['value']-$E[3]['value'])) {			//Einschalttemperatur erreicht
					logic_setOutput($id,1,1); 	//Status Dauerladung Ein
					logic_setOutput($id,7,1); 	//Boiler Ein
				} else {														//Ausschalttemperatur erreicht
					logic_setVar($id,2,0);		//Einmalladung A deaktiviert
					logic_setVar($id,3,0);		//Einmalladung B deaktiviert
					logic_setOutput($id,1,0); 	//Status Dauerladung Aus
					logic_setOutput($id,2,0); 	//Status Einmalladung A Aus
					logic_setOutput($id,3,0); 	//Status Einmalladung B Aus
					logic_setOutput($id,7,0); 	//Boiler Aus
				}
			} else {															//Deaktivieren
				logic_setVar($id,1,0);			//Dauerladung deaktiviert
				logic_setOutput($id,1,0); 		//Status Dauerladung Aus
				logic_setOutput($id,7,0); 		//Boiler Aus
			
			}			
		}


		//Ist-Temperatur-Änderung triggert die Überwachung (bzw. ein Refresh von E1/E4/E7)
		//-----------------------------------
		if ($E[10]['refresh']==1 || $refresh) {
			//Temperatur-Check für A4/A5/A6
			if ($E[10]['value']>($E[2]['value']-$E[3]['value'])) {logic_setOutput($id,4,1);} else {logic_setOutput($id,4,0);}
			if ($E[10]['value']>($E[5]['value']-$E[6]['value'])) {logic_setOutput($id,5,1);} else {logic_setOutput($id,5,0);}
			if ($E[10]['value']>($E[8]['value']-$E[9]['value'])) {logic_setOutput($id,6,1);} else {logic_setOutput($id,6,0);}

			//Solltemperatur erreicht, bzw. bei Dauerladung zusätzlich: Einschalttemperatur erreicht?
			if (logic_getVar($id,2)==1) {				//Einmalladung A aktiv?
				if ($E[10]['value']>=$E[5]['value']) {	//Solltemperatur erreicht?
					logic_setVar($id,2,0);		//Einmalladung A aus
					logic_setOutput($id,2,0); 	//Status Einmalladung A Aus
					logic_setOutput($id,7,0); 	//Boiler Aus
				}
			} else if (logic_getVar($id,3)==1) {		//Einmalladung B aktiv?
				if ($E[10]['value']>=$E[8]['value']) {	//Solltemperatur erreicht?
					logic_setVar($id,3,0);		//Einmalladung B aus
					logic_setOutput($id,3,0); 	//Status Einmalladung B Aus
					logic_setOutput($id,7,0); 	//Boiler Aus
				}
			} else if (logic_getVar($id,1)==1) {		//Dauerladung aktiv?
				if ($E[10]['value']>=$E[2]['value']) {	//Solltemperatur erreicht?
					logic_setOutput($id,1,0); 	//Status Dauerladung Aus
					logic_setOutput($id,7,0); 	//Boiler Aus
				} else if ($E[10]['value']<=($E[2]['value']-$E[3]['value'])) {	//Einschalttemperatur erreicht?
					logic_setOutput($id,1,1); 	//Status Dauerladung Ein
					logic_setOutput($id,7,1); 	//Boiler Ein
				}
			}
		}

	}
}
?>
###[/LBS]###


###[EXEC]###
<?
?>
###[/EXEC]###