/* 
 * EDOMI beta (Version 1.54) - Intelligente Steuerung und Visualisierung KNX-basierter Elektro-Installationen.
 * @link http://www.edomi.de 
 * @author Dr. Christian Gärtner <dr.christian.gaertner@googlemail.com> 
 * @copyright 2015,2016,2017 Dr. Christian Gärtner 
 * @license Freeware 
 *
 *     This file and all other files are part of EDOMI.
 *
 *     EDOMI is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 *     Diese und alle anderen Dateien sind Teil von EDOMI.
 *
 *     EDOMI wird in der Hoffnung, dass es nützlich sein wird, aber
 *     OHNE JEDE GEWÄHRLEISTUNG, bereitgestellt; sogar ohne die implizite
 *     Gewährleistung der MARKTFÄHIGKEIT oder EIGNUNG FÜR EINEN BESTIMMTEN ZWECK.
*/ 
//Controltyp 14 (Liste/Tabelle)
//----------------------------

function control14_constructControl(obj,item) {

	var mheight=(obj.dataset.var10!='')?obj.dataset.var10:40;

	var n="<table cellpadding='0' cellspacing='0' border='0' style='position:absolute; left:0; top:0; width:100%; height:100%;'>";
		n+="<tr id='e-"+item.id+"-scroll' style='height:"+mheight+"px; display:none;'>";
			n+="<td width='50%' align='center' id='e-"+item.id+"-last'>&larr;</td>";
			n+="<td width='50%' align='center' id='e-"+item.id+"-next'>&rarr;</td>";
		n+="</tr>";
		n+="<tr><td colspan='2' id='e-"+item.id+"-scroll2'><div style='position:relative; height:100%;'><div id='e-"+item.id+"-edit' style='position:absolute; top:0; left:0; right:0; bottom:0; overflow-x:hidden; overflow-y:auto;'></div></div></td></tr>";
	n+="</table>";
	obj.innerHTML=n;
	
	if (obj.dataset.var0==1) {document.getElementById("e-"+item.id+"-edit").addEventListener(downEvent,function(){if (!checkClick()){return;} visuElementClick(item.id);},false);}

	document.getElementById("e-"+item.id+"-last").addEventListener(downEvent,function(){if (!checkClick()){return;} showShortClickItem(this); scrollUp("e-"+item.id+"-edit");},false);
	document.getElementById("e-"+item.id+"-next").addEventListener(downEvent,function(){if (!checkClick()){return;} showShortClickItem(this); scrollDown("e-"+item.id+"-edit");},false);
}

function control14_refreshControl(obj,init) {
	var kovalue=getKoValue(obj);
	control14_Refresh(obj.dataset.id,pS(obj.dataset.d_text,kovalue));
}

function control14_Refresh(elementId,list) {
	var d=document.getElementById("e-"+elementId);
	if (d) {

		var obj=document.getElementById("e-"+elementId+"-edit");
		var rows=list.split(d.dataset.var1);
		var rowsMax=rows.length;
		if (rows[rowsMax-1]=="") {
			rows.pop();
			rowsMax--;
		}	
		
		if (rowsMax>0) {
			//Spalten erzeugen:
			var cols=new Array();
			var colsMax=1;
			if (d.dataset.var2=="") {
				for (var t=0;t<rowsMax;t++) {cols[t]=[rows[t]];}
			} else {
				for (var t=0;t<rowsMax;t++) {
					cols[t]=rows[t].split(d.dataset.var2);
					if (cols[t].length>colsMax) {colsMax=cols[t].length;}
				}
			}

			//Sortieren (ggf. ohne 1. Zeile):
			if (d.dataset.var7>=1) {var titel=cols.shift();}
			if (d.dataset.var3==1) {
				cols.sort();
			} else if (d.dataset.var3==2) {
				cols.sort();
				cols.reverse();
			} else if (d.dataset.var3==3 || d.dataset.var3==5) {
				cols.sort(sort1up);
			} else if (d.dataset.var3==4 || d.dataset.var3==6) {
				cols.sort(sort1down);
			}
			if (d.dataset.var7>=1) {cols.unshift(titel);}

			//Ausgabe:
			colsStart=0;
			if ((d.dataset.var3==5 || d.dataset.var3==6) && colsMax>1) {colsStart=1;}	//ggf. 1. Spalte ausblenden:
			if (d.dataset.var4==0) {
				var h="";
				var n="<table cellpadding='"+d.dataset.var5+"' cellspacing='0' border='0' style='width:100%; height:100%;'>";
			} else {
				var h=" height='"+d.dataset.var4+"'";
				var n="<table cellpadding='"+d.dataset.var5+"' cellspacing='0' border='0' style='width:100%;'>";
			}
			
			if (d.dataset.var7>=1) {	//Titelzeile: ggf. Spaltenbreite setzen
				var tmp="";
				var isSet=false;
				for (var tt=colsStart;tt<colsMax;tt++) {
					if (cols[0][tt]) {
						var meta=cols[0][tt].split("***");
						if (meta.length==2 && !isNaN(parseFloat(meta[1]))) {
							tmp+="<col width='"+parseFloat(meta[1])+"%'>";
							isSet=true;
						} else {
							tmp+="<col width=''>";
						}
						cols[0][tt]=meta[0];
					}
				}
				if (isSet) {n+="<colgroup>"+tmp+"</colgroup>";}
			}			
			
			for (var t=0;t<rowsMax;t++) {
				var b1="";
				if (t<(rowsMax-1) && (d.dataset.var6==1 || d.dataset.var6==3)) {b1="border-bottom:1px dotted;";}
				if (t==0 && d.dataset.var7>=1) {
					//Titelzeile
					b1="border-bottom:1px solid; font-weight:bold;";
					if (d.dataset.var7==2) {n+="<tr height='1'>";} else {n+="<tr"+h+">";}
				} else {
					n+="<tr"+h+">";
				}
				for (var tt=colsStart;tt<colsMax;tt++) {
					if (cols[t][tt]!==undefined) {var col=cols[t][tt];} else {var col="&nbsp;";}
					var b2="";
					if (tt<(colsMax-1) && (d.dataset.var6==2 || d.dataset.var6==3)) {b2="border-right:1px dotted;";}
					n+="<td style='"+b1+b2+"'>"+col+"</td>";
				}
				n+="</tr>";
			}
			n+="</table>";			
			obj.innerHTML=n;
		} else {
			//keine Daten (wichtig für ClickEvent!)
			obj.innerHTML="<table cellpadding='0' cellspacing='0' border='0' style='width:100%; height:100%;'><tr><td>&nbsp;</td></tr></table>";
		}

		if (d.dataset.var8==1 || parseInt(obj.scrollHeight)>parseInt(obj.clientHeight)) {
			document.getElementById("e-"+elementId+"-scroll").style.display="table-row";
			document.getElementById("e-"+elementId+"-scroll2").style.borderTop="1px solid";
		} else {
			document.getElementById("e-"+elementId+"-scroll").style.display="none";
			document.getElementById("e-"+elementId+"-scroll2").style.borderTop="none";
		}
	}

	function sort1up(a,b) {
		if (a[0]===b[0]) {
			return 0;
		} else {
			return (a[0]<b[0])?-1:1;
		}
	}
	
	function sort1down(a,b) {
		if (a[0]===b[0]) {
			return 0;
		} else {
			return (a[0]>b[0])?-1:1;
		}
	}
}
